


// library inclusions
//import java.lang.*;
import waba.ui.*;
import waba.fx.*;
import waba.io.*;
import waba.sys.*;



public class WHash extends MainWindow
{
    Button  generateNumberBtn;
    Edit    classNameEdit, nmNameEdit, nmDescriptionEdit, generatedNmHashCodeEdit;
    Label   classNameLabel, nmNameLabel, generatedNmHashCodeLabel, titleLabel01, titleLabel02;
    Label   nmDescriptionLabel01, nmDescriptionLabel02, nmDescriptionLabel03;


    public WHash()
	{
	    Font font = new Font("Helvetica", Font.BOLD, 18);

	    titleLabel01 = new Label("WabaVM Native Method");
	    titleLabel01.setRect(16, 8, 180, 18);
	    titleLabel01.setFont(font);
	    add(titleLabel01);

	    titleLabel02 = new Label("Hash Code Generator");
	    titleLabel02.setRect(16, 28, 180, 18);
	    titleLabel02.setFont(font);
	    add(titleLabel02);




        classNameLabel = new Label("Enter Class Name Below:");
	    classNameLabel.setRect(16, 40, 180, 18);
	    add(classNameLabel);

        classNameEdit = new Edit();
	    classNameEdit.setText("");
	    classNameEdit.setRect(16, 60, 180, 18);
	    add(classNameEdit);



        nmNameLabel = new Label("Enter Native Method Name Below:");
	    nmNameLabel.setRect(16, 80, 180, 18);
	    add(nmNameLabel);

	    nmNameEdit = new Edit();
	    nmNameEdit.setText("");
	    nmNameEdit.setRect(16, 100, 180, 18);
	    add(nmNameEdit);



        nmDescriptionLabel01 = new Label("Enter Native Method Descripter Below:");
	    nmDescriptionLabel01.setRect(16, 120, 180, 18);
	    add(nmDescriptionLabel01);

	    nmDescriptionLabel02 = new Label("i.e. If there are 3 interges in the parameter (III)V");
	    nmDescriptionLabel02.setRect(16, 140, 220, 18);
	    add(nmDescriptionLabel02);

	    nmDescriptionEdit = new Edit();
	    nmDescriptionEdit.setText("");
	    nmDescriptionEdit.setRect(16, 160, 180, 18);
	    add(nmDescriptionEdit);



        generateNumberBtn = new Button("Click Here To Get The Magic Number !");
	    generateNumberBtn.setRect(16, 200, 180, 18);
	    add(generateNumberBtn);

	    generatedNmHashCodeEdit = new Edit();
	    generatedNmHashCodeEdit.setText("");
	    generatedNmHashCodeEdit.setRect(16, 220, 180, 18);
	    add(generatedNmHashCodeEdit);
	}



    public void onPaint(Graphics scr)
	{
	    //scr.setColor(0, 0, 0);
	    //scr.drawLine(160, 0, 160, 160);
	    //scr.drawLine(0, 160, 160, 160);
	}



    public void onEvent(Event event)
	{
	    if(event.type == ControlEvent.PRESSED)
		{
		    if(event.target == generateNumberBtn)
			{
			    String generatedNmHashedStr = getHashCode(  "waba/fx/Graphic", //classNameEdit.getText(),
			                                                "free", //nmNameEdit.getText(),
			                                                "()V" /*nmDescriptionEdit.getText()*/);

			    generatedNmHashCodeEdit.setText(generatedNmHashedStr);
			}
		}
	}



	public String getHashCode(String classNameStr, String nmNameStr, String nmDescriptionStr)
	{
	    String generatedNmHashedStr;
	    long classHash, methodHash;
	    long hash;
hash = 218212410 * 10 + 3; //2147483648//
	    //Desc is for function parameter description.
        classHash = generateNmHashCode(classNameStr) % 65536; //The result is 0x8210, and 33296 in decimal.
        
        //"methodHash", the result is 0x9247, and 37447 in decimal.
        methodHash = (generateNmHashCode(nmNameStr) + generateNmHashCode(nmDescriptionStr)) % 65536;
        hash = ((classHash << 16) + methodHash);
        

        //classHash first
        //for(int index1=16; index1 > 0; index1--)
        //{
            //for(int index2=0; index2 < 16; index2++)
            //{
                /*hashDigitsArray[0] = classHash & 0x0000F000;
                hashDigitsArray[1] = classHash & 0x00000F00;
                hashDigitsArray[2] = classHash & 0x000000F0;
                hashDigitsArray[3] = classHash & 0x0000000F;*/
            //}
        //}

        //hash = (4294967295 - hash) + 1;
        //hash = hashDigitsArray[0]+hashDigitsArray[1]+hashDigitsArray[2]+hashDigitsArray[3];
        //hash = (0xFFFFFFFF - hash);
        //hash = ~hash+1;//-hash;
        //hashHighInt = hash >> 16;
        //hashLowInt  = hash & 0x0000FFFF;

        //hash = 0xFFFFFFFF - hash;
        generatedNmHashedStr  = String.valueOf(hash);
        //generatedNmHashedStr += String.valueOf(hashDigitsArray[1]);
        //generatedNmHashedStr += String.valueOf(hashDigitsArray[2]);
        //generatedNmHashedStr += String.valueOf(hashDigitsArray[3]);

	    return generatedNmHashedStr;
	}



	long generateNmHashCode(String nmNameStr)
    {
        long value;
        int index;

        value = 0;

        for(index=0; index < nmNameStr.length(); index++)
        {
            value += nmNameStr.charAt(index);
        }

        value = (value << 6) + nmNameStr.length();

        return value;
    }
}//End of class


