


// library inclusions
import java.lang.*;
//import waba.ui.*;
//import waba.fx.*;
//import waba.io.*;
//import waba.sys.*;



public class JWHash
{
    public static void main(String[] args)
    {        
        JWHash jwHashMain = new JWHash();
        
        System.out.println();
        System.out.println("[[[ WabaVM Native Method" + " Hash Code Generator " + "Tool ]]]");
        System.out.println();
        System.out.println("String has " + args.length + " element(s)");
        System.out.println();
        
        for(int i=0; i < args.length; i+=3)
        {
            System.out.println(args[i] + "_" + args[i+1] + "_" + args[i+2]);
            String generatedNmHashedStr = jwHashMain.getHashCode(args[i], args[i+1], args[i+2]);
            System.out.println("The hash code for the native method is : " + generatedNmHashedStr + "ul");
            System.out.println();
        }	    
    }



	public String getHashCode(String classNameStr, String nmNameStr, String nmDescriptionStr)
	{
	    String generatedNmHashedStr;
	    long hash, classHash, methodHash;

	    //Desc is for function parameter description.
        classHash = generateNmHashCode(classNameStr) % 65536;
        methodHash = (generateNmHashCode(nmNameStr) + generateNmHashCode(nmDescriptionStr)) % 65536;
        hash = ((classHash << 16) + methodHash);

        //System.out.println(classHash);
        //System.out.println(methodHash);
        //System.out.println(classHash << 16);
        //System.out.println(hash);

        generatedNmHashedStr  = String.valueOf(hash);

	    return generatedNmHashedStr;
	}



	long generateNmHashCode(String nmNameStr)
    {
        long value;
        int index;

        value = 0;

        for(index=0; index < nmNameStr.length(); index++)
        {
            value += nmNameStr.charAt(index);
        }

        value = (value << 6) + nmNameStr.length();

        return value;
    }
}//End of class


